extern bool less_combinations=0,FixedLots=1;
extern double SLTSxAvgBars=1,TPxSLTS=20;
extern int T=17,C1=0,C2=0,C3=0,C4=0,C5=0,C6=0,C7=0,C8=0,C9=0,C10=0,
 C11=0,C12=0,C13=0,C14=0,C15=0,C16=0,C17=0,C18=0;
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int tot,tmpf,i,j,di,order=-1,p2p=1,time=0,cper;
double x_factor,ts,tp,pnt,cp,op,lot,PRA,TT,TR[2],lotd,minl,spr,
 pval,funds,stepl,maxl,available,costrisk;
string sy;
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int init() {
  sy=Symbol(); cper=Period(); di=MarketInfo(sy,12); pnt=Point;
  if(di==3){pnt=0.01;p2p=10;} if(di==5){pnt=0.0001;p2p=10;}
  minl=MarketInfo(sy,23); pval=MarketInfo(sy,16);lot=minl;
  stepl=MarketInfo(sy,24); maxl=MarketInfo(sy,25);
  if(!GlobalVariableCheck("PercentRiskAccount"))
   GlobalVariableSet("PercentRiskAccount",1);
  PRA=MathMax(0.00000001,GlobalVariableGet("PercentRiskAccount"));
  if(!(maxl>0.0)) maxl=999999999;
  tot=C1+C2+C3+C4+C5+C6+C7+C8+C9+C10+C11+C12+C13+C14+C15+C16+C17+C18;
  if(tot-1<T||tot+T<1)return(-1);
  if(less_combinations){
   if(C1+C2>1||C3+C4>1||C5+C6>1||C7+C8>1||C9+C10>1)return(-1);
   if(C11+C12>1||C13+C14>1||C15+C16>1||C17+C18>1)return(-1);}
  return(0); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int start() {
 if(tot-1<T||tot+T<1)return(-1);
 if(less_combinations){
  if(C1+C2>1||C3+C4>1||C5+C6>1||C7+C8>1||C9+C10>1)return(-1);
  if(C11+C12>1||C13+C14>1||C15+C16>1||C17+C18>1)return(-1);}
 if(!CheckBars())return(0);
 if(CheckSignal()) CheckForOpen(); 
 CheckForClose(); return(0); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int CheckForOpen() {
  if(CheckOrders()) return(0); if(CalcLots()<minl) return(0);
  if(order==0) { TR[0]=Bid-ts; return(fOpen(0,Ask)); }
  if(order==1) { TR[1]=Ask+ts; return(fOpen(1,Bid)); }
  return(0); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
bool CheckOrders(){
  for(i=0;i<OrdersTotal();i++) {
   if(!OrderSelect(i,SELECT_BY_POS)) continue;
   if(OrderType()==order) return(1); }
  if(OrderSelect(OrdersHistoryTotal()-1,SELECT_BY_POS,MODE_HISTORY)) 
   if(OrderType()==order&&OrderCloseTime()==Time[0]) return(1);
  return(0); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
double CalcLots() {
  if(FixedLots)return(minl); if(lot>0.0) lot=0.0;
  funds=MathMin(AccountBalance(),AccountEquity());
  if(AccountStopoutMode()==0)
   funds-=0.01*AccountStopoutLevel()*MathMax(AccountBalance(),AccountEquity());
  if(AccountStopoutMode()==1) funds-=AccountStopoutLevel();
  funds-=AccountMargin();
  if(!(funds>0.0)) return(0);
  lotd=MarketInfo(sy,32);
  if(!(lotd>0.0)) return(0);
  available=funds/lotd;
  if(available<minl) return(0);
  costrisk=(x_factor+ts)/pnt*available*pval+funds;
  if(available/costrisk*funds<minl) return(0); if(!(stepl>0.0))stepl=minl;
  tmpf=MathMax(funds/lotd/costrisk*funds*0.01*PRA,minl)/stepl;
  lot=MathMin(maxl,tmpf*stepl);
  return(lot); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int CheckForClose()
 {
  for(i=0;i<OrdersTotal();i++) {
    if(!OrderSelect(i,SELECT_BY_POS)) continue;
    cp=OrderClosePrice(); op=OrderOpenPrice(); j=OrderType();
    if(MathAbs(op-cp)>tp && OrderProfit()>0.0) {if(fClose()) continue;}
    TT=MathMax(MathAbs(cp-op)*0.2,ts);
    if(j==0) { if(TR[0]<cp-TT) TR[0]=cp-TT;
     if(TR[0]>cp) {if(fClose()) continue;} }
    if(j==1) { if(TR[1]>cp+TT) TR[1]=cp+TT;
     if(TR[1]<cp) {if(fClose()) continue;} } }
  return(0); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
bool fOpen(int sot, double sop) {
  int res=OrderSend(sy,sot,lot,sop,5*p2p,0.0,0.0,"",0,0); return(res); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
bool fClose() {return(OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),5*p2p)); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
bool CheckSignal() {
  bool ob=0,os=0;int buy=0,sell=0;order=-1;
  double h0=iCustom(sy,cper,"HAe",0,0),
        h1=iCustom(sy,cper,"HAe",0,1),
       h2=iMACD(sy,cper,12,26,9,0,0,0),
      h3=iMACD(sy,cper,12,26,9,0,1,0),
     h4=iAC(sy,cper,0),
    h5=iAC(sy,cper,1),
   h6=iAC(sy,cper,2);
  if(h0*C1>0.0)buy++;if(h0*C1<0.0)sell++;
  if(h0*C2<0.0)buy++;if(h0*C2>0.0)sell++;
  if(h1*C3>0.0)buy++;if(h1*C3<0.0)sell++;
  if(h1*C4<0.0)buy++;if(h1*C4>0.0)sell++;
  if(h2*C5>0.0)buy++;if(h2*C5<0.0)sell++;
  if(h2*C6<0.0)buy++;if(h2*C6>0.0)sell++;
  if(h3*C7>0.0)buy++;if(h3*C7<0.0)sell++;
  if(h3*C8<0.0)buy++;if(h3*C8>0.0)sell++;
  if(h4*C9>0.0)buy++;if(h4*C9<0.0)sell++;
  if(h4*C10<0.0)buy++;if(h4*C10>0.0)sell++;
  if(h0*C11>h1*C11)buy++;if(h0*C11<h1*C11)sell++;
  if(h0*C12<h1*C12)buy++;if(h0*C12>h1*C12)sell++;
  if(h2*C13>h3*C13)buy++;if(h2*C13<h3*C13)sell++;
  if(h2*C14<h3*C14)buy++;if(h2*C14>h3*C14)sell++;
  if(h4*C15>h5*C15)buy++;if(h4*C15<h5*C15)sell++;
  if(h4*C16<h5*C16)buy++;if(h4*C16>h5*C16)sell++;
  if(h5*C17>h6*C17)buy++;if(h5*C17<h6*C17)sell++;
  if(h5*C18<h6*C18)buy++;if(h5*C18>h6*C18)sell++;

  if(buy-sell>0&&buy>T)order=0;
  if(sell-buy>0&&sell>T)order=1;
  return(order>-1); }
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
bool CheckBars() {
  if(time+Period()*10*60>Time[0])return(1); double hl; x_factor=0.0;
  for(i=0;i<20;i++){
   hl=High[i]-Low[i+1]; x_factor+=MathMax(High[i+1]-Low[i],hl); }
  if(x_factor>0.0){x_factor/=20;time=Time[0];} 
  ts=x_factor*SLTSxAvgBars; tp=ts*TPxSLTS; return(x_factor>0.0);}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

